module filter_sos(x,y,clock,reset);
parameter a1 = 8'd6, a2 = 8'd4;
parameter b0 = 8'd16;
parameter b1 = 8'd0;
parameter b2 = 8'd0;
input [7:0] x;
output [7:0] y;
input clock,reset;
wire [7:0] w,wm1,wm2;
wire [15:0] asum1,bsum1,asum2,bsum2,wsum,result;

delay d1(w,wm1,clock,reset), d2(wm1,wm2,clock,reset);
multiplier2 mul1(wm2,a2,asum1), mul2(wm2,b2,bsum1);
multiplier1 mac1(asum1,wm1,a1,asum2), mac2(bsum1,wm1,b1,bsum2);
multiplier1 mac3(bsum2,w,b0,result);
adder2 add1({4'd0,x,4'd0},asum2,wsum);
// scale by 4 and truncate output
assign w = wsum[11:4];
assign y = result[11:4]; 
endmodule
